<!-- TODO: порефакторить таблицу в список разделов, в каждом развернуть рекомендации подробнее и сделать кросс-ссылки с пошаговой инструкцией по решению проблемы с отсуствием данных на графике -->

Тип ошибки|Описание ошибки|Рекомендации
----------|---------------|------------
`CONNECT_FAILURE` | Solomon не смог установить соединение с пользовательским приложением | Проверить наличие [сетевых доступов](../network_access.md#access-pull) между кластером Solomon и пользовательским приложением.
`DERIV_AND_TS` | В полученных данных содержатся метки времени (timestamp) для RATE-метрик. | Не передавать метки времени для RATE-метрик.
`IPC_QUEUE_OVERFLOW` | Solomon не успевает записывать в хранилище поток данных, поступающих в шард. | Если ошибка сохраняется в течение 10 минут, [свяжитесь с командой Solomon](../problems/howtoreport.md#data-collection).
`JSON_ERROR` | Пользовательское приложение передает метрики в некорректном [JSON-формате](../concepts/../data-collection/dataformat/json.md). | Проверить корректность передаваемых данных.
`NOT_200` | URL, опрашиваемый Solomon для получения метрик, вернул код ответа отличным от HTTP 200 или 204 | Проверить работоспособность опрашиваемого приложения или корректность URL, указанного в настройках сервиса.
`QUOTA_ERROR`<br/>(ранее `SENSOR_OVERFLOW`) | Превышена одна из квот на шард | Уменьшить потребление, либо [создать запрос на изменение квот](../problems/howtoreport.md#quotas).
`RESPONSE_TOO_LARGE` | Полученный от пользовательского приложения ответ превышает ограничение *Max response size*, установленное в настройках шарда. | Уменьшить потребление, либо [создать запрос на изменение квот](../problems/howtoreport.md#quotas).
`SENSOR_OVERFLOW` | Ошибка возникает при использовании Solomon Agent, когда поток записи в агент превышает скорость, с которой Solomon забирает данные из агента (Max sensors per URL раз в Pull interval секунд) |
`SHARD_NOT_INITIALIZED` | Шард перезагружается (например, переназначается на другой хост Solomon). | Если ошибка сохраняется в течение 10 минут, [свяжитесь с командой Solomon](../problems/howtoreport.md#data-collection).
`SKIP_TOO_LONG` | Solomon получает от пользовательского приложения дольше, чем период, с которым опрашиваются хосты. | Уменьшить размер ответа, или связаться с командой Solomon с просьбой увеличить ограничение. | Увеличить время опроса хостов, либо ускорить время ответа приложения.
`SPACK_ERROR` | Пользовательское приложение передает метрики в некорректном SPACK-формате. | Проверить корректность передаваемых данных.
`TIMEOUT` | Solomon смог установить соединение с пользовательским приложением, но не получил от него ответ за время, равное периоду опроса хостов (параметр *Interval* в настройках сервиса). | Увеличить время опроса хостов, либо ускорить время ответа приложения.
`UNKNOWN_ERROR` | Неизвестная ошибка | Если ошибка сохраняется в течение 10 минут, [свяжитесь с командой Solomon](../problems/howtoreport.md#data-collection).
`UNKNOWN_HOST` | Solomon не смог определить IP-адрес для опрашиваемого хоста и установить с ним соединение. | Проверить конфигурацию кластера, либо наличие записей в DNS для указанных хостов.

<!-- `AUTH_ERROR` | |  -->
<!-- `PARSE_ERROR` | | -->
<!-- `SHARD_IS_NOT_WRITABLE` | | -->
<!-- `UNKNOWN_PROJECT` | | -->
<!-- `UNKNOWN_SHARD` | |  -->
<!-- `UNKNOWN_STATUS_TYPE` | | -->

<!-- https://a.yandex-team.ru/arc_vcs/solomon/protos/common/url_info.proto?rev=r7592735#L11 -->
