JAVA_PROGRAM()

OWNER(g:solomon)

INCLUDE(${ARCADIA_ROOT}/solomon/libs/java/contribs.inc)

PEERDIR(
    # Spring
    contrib/java/org/springframework/spring-beans
    contrib/java/org/springframework/spring-context
    contrib/java/org/springframework/spring-jdbc
    contrib/java/org/springframework/spring-tx

    contrib/java/com/google/code/findbugs/jsr305/3.0.2
    contrib/java/com/google/code/gson/gson/2.4
    contrib/java/com/google/guava/guava
    contrib/java/com/google/protobuf/protobuf-java
    contrib/java/javax/annotation/javax.annotation-api
    contrib/java/net/jpountz/lz4/lz4/1.3.0
    contrib/java/org/apache/commons/commons-dbcp2/2.1.1
    contrib/java/joda-time/joda-time/2.4
    contrib/java/commons-collections/commons-collections/3.2
    contrib/java/commons-io/commons-io/2.4
    contrib/java/org/apache/commons/commons-lang3
    contrib/java/org/slf4j/slf4j-api
    contrib/java/junit/junit/4.12
    contrib/java/com/fasterxml/jackson/core/jackson-core
    contrib/java/com/fasterxml/jackson/core/jackson-databind
    contrib/java/com/fasterxml/jackson/core/jackson-annotations

    iceberg/misc-cmdline

    library/java/svnversion

    solomon/libs/java/kikimr-kv-client

    solomon/graphite/mega-graphite-storage/storage-proto
    solomon/libs/java/auth
    solomon/libs/java/config
    solomon/libs/java/discovery
    solomon/libs/java/http-filters
    solomon/libs/java/main
    solomon/libs/java/selfmon
    solomon/libs/java/staff-only
    solomon/libs/java/stockpile-client
    solomon/libs/java/util
    solomon/libs/java/ydb
)

EXCLUDE(
#    contrib/java/org/eclipse/jetty
    contrib/java/org/samba/jcifs
    contrib/java/org/aspectj
#    contrib/java/commons-logging
    contrib/java/logkit
    contrib/java/org/jaudiotagger
    contrib/java/org/apache/wicket
    contrib/java/org/easymock
    contrib/java/org/mockito
    contrib/java/com/ibm/icu/icu4j
    contrib/java/net/sf/saxon
    contrib/java/xalan
    contrib/java/xerces
    contrib/java/ru/yandex/qe/commons-logging # bad people added logback.xml to classpath

    # We have netty-all; we do not need any old conflicting versions
    contrib/java/io/netty/netty-common
    contrib/java/io/netty/netty-codec
    contrib/java/io/netty/netty-buffer
    contrib/java/io/netty/netty-handler
    contrib/java/io/netty/netty-transport
    contrib/java/io/netty/netty-resolver
    contrib/java/io/netty/netty-resolver-dns

    iceberg/inside-golem
    iceberg/inside-juggler
    iceberg/inside-nanny

    contrib/java/org/apache/lucene
    ${service_excludes}
)

INCLUDE(${ARCADIA_ROOT}/solomon/libs/java/jdk.inc)

JAVA_SRCS(
    SRCDIR graphouse/src/java
    **/*.java
    **/*.xml
    **/*.yql
)

LINT(base)
END()

RECURSE_FOR_TESTS(ut)
