#pragma once

#include "iam.h"

#include <library/cpp/monlib/metrics/fwd.h>

namespace NSolomon::NCloud {
    class TDefaultCounters final: public ICounters {
    public:
        TDefaultCounters(NMonitoring::TMetricRegistry& r);

        void Fail() override;
        void Success() override;
        void SetTokenAge(TDuration) override;
        void SetRemainingLifetime(TDuration) override;

    private:
        NMonitoring::TCounter* Fail_{};
        NMonitoring::TCounter* Success_{};
        NMonitoring::TIntGauge* TokenAge_{};
        NMonitoring::TIntGauge* TokenRemaining_{};
    };
} // namespace NSolomon::NCloud
