package tracker

import "strconv"

const (
	SolomonReleaseID = 38167
)

var (
	SolomonQueue   = Queue{ID: "670", Key: "SOLOMON"}
	SolomonRelease = Component{ID: strconv.Itoa(SolomonReleaseID)}
)

func IsSolomonReleaseIssue(issue *Issue) bool {
	for _, c := range issue.Components {
		if c.ID == SolomonRelease.ID {
			return true
		}
	}
	return false
}
