JAVA_LIBRARY(auth)

OWNER(g:solomon)

INCLUDE(${ARCADIA_ROOT}/solomon/libs/java/jdk.inc)

JAVA_SRCS(
    PACKAGE_PREFIX ru.yandex.solomon.auth
    SRCDIR src
    **/*.java
)

INCLUDE(${ARCADIA_ROOT}/solomon/libs/java/contribs.inc)

PEERDIR(
    solomon/libs/java/config
    solomon/libs/java/discovery
    solomon/libs/java/secrets
    solomon/libs/java/selfmon
    solomon/libs/java/staff-only-annotations
    solomon/libs/java/yandex/abc
    solomon/libs/java/yandex/blackbox
    solomon/libs/java/yandex/cloud-session

    library/java/tvmauth

    contrib/java/org/apache/commons/commons-lang3
    contrib/java/com/google/code/findbugs/jsr305/3.0.2
    contrib/java/org/slf4j/slf4j-api
    contrib/java/com/google/guava/guava

    # jackson
    contrib/java/com/fasterxml/jackson/core/jackson-core
    contrib/java/com/fasterxml/jackson/core/jackson-databind

    # spring
    contrib/java/org/springframework/spring-web
    contrib/java/org/springframework/spring-webflux

    # cloud
    contrib/java/yandex/cloud/cloud-auth-impl/20603-c7ed3c926c
    contrib/java/yandex/cloud/cloud-auth-api/20603-c7ed3c926c
)


LINT(base)
END()

RECURSE_FOR_TESTS(ut)
