package ru.yandex.solomon.cloud.resource.resolver;

import java.util.concurrent.CompletableFuture;

import javax.annotation.ParametersAreNonnullByDefault;

import ru.yandex.solomon.labels.shard.ShardKey;

import static java.util.concurrent.CompletableFuture.completedFuture;

/**
 * @author Stanislav Kashirin
 */
@ParametersAreNonnullByDefault
public final class FolderResolverNoOp implements FolderResolver {
    @Override
    public CompletableFuture<String> resolveFolderId(ShardKey shardKey) {
        return completedFuture("");
    }

    @Override
    public CompletableFuture<String> resolveFolderId(String projectId, String clusterName) {
        return completedFuture("");
    }
}
