package ru.yandex.solomon.core.db.dao.memory;

import java.util.List;
import java.util.Optional;
import java.util.concurrent.CompletableFuture;

import ru.yandex.solomon.core.db.dao.ClustersDao;
import ru.yandex.solomon.core.db.model.Cluster;
import ru.yandex.solomon.ydb.page.PageOptions;
import ru.yandex.solomon.ydb.page.PagedResult;
import ru.yandex.solomon.ydb.page.TokenBasePage;

import static java.util.concurrent.CompletableFuture.runAsync;

/**
 * @author Alexey Trushkin
 */
public class InMemoryClustersDao implements ClustersDao {

    @Override
    public CompletableFuture<Void> createSchemaForTests() {
        return runAsync(() -> {
        });
    }

    @Override
    public CompletableFuture<Void> dropSchemaForTests() {
        return runAsync(() -> {
        });
    }

    @Override
    public CompletableFuture<Boolean> insert(Cluster cluster) {
        return CompletableFuture.completedFuture(false);
    }

    @Override
    public CompletableFuture<Optional<Cluster>> findOne(String projectId, String folderId, String clusterId) {
        return CompletableFuture.completedFuture(Optional.empty());
    }

    @Override
    public CompletableFuture<PagedResult<Cluster>> findByProjectId(String projectId, String folderId, PageOptions pageOpts, String text) {
        return CompletableFuture.completedFuture(PagedResult.empty());
    }

    @Override
    public CompletableFuture<List<Cluster>> findAll() {
        return CompletableFuture.completedFuture(List.of());
    }

    @Override
    public CompletableFuture<PagedResult<Cluster>> findAll(PageOptions pageOpts, String text) {
        return CompletableFuture.completedFuture(PagedResult.empty());
    }

    @Override
    public CompletableFuture<Optional<Cluster>> partialUpdate(Cluster cluster) {
        return CompletableFuture.completedFuture(Optional.empty());
    }

    @Override
    public CompletableFuture<Boolean> deleteOne(String projectId, String folderId, String clusterId) {
        return CompletableFuture.completedFuture(false);
    }

    @Override
    public CompletableFuture<Void> deleteByProjectId(String projectId, String folderId) {
        return CompletableFuture.completedFuture(null);
    }

    @Override
    public CompletableFuture<Boolean> exists(String projectId, String folderId, String clusterId) {
        return CompletableFuture.completedFuture(false);
    }

    @Override
    public CompletableFuture<TokenBasePage<Cluster>> findByProjectIdPaged(String projectId, String folderId, int pageSize, String pageToken, String text) {
        return CompletableFuture.completedFuture(TokenBasePage.empty());
    }
}
