PROTO_LIBRARY(solomon-config-protos)

OWNER(g:solomon)
SRCS(
    # Common
    common/abc_config.proto
    common/ambry_config.proto
    common/cluster_config.proto
    common/retry_config.proto
    common/mail/mail_config.proto
    common/idm_config.proto
    common/kikimr_config.proto
    common/logbroker_config.proto
    common/project_manager_client_config.proto
    common/resource_manager_client_config.proto
    common/unified_agent_config.proto
    common/staff_config.proto
    common/yasms_config.proto
    common/iam_token_config.proto
    common/task_scheduler_config.proto

    # Stockpile
    stockpile/stockpile_client_config.proto
    stockpile/solomon_stockpile_config.proto

    # Metabase
    metabase/metabase_client_config.proto
    metabase/solomon_metabase_config.proto

    # Alerting
    alerting/solomon_alerting_config.proto
    alerting/alerting_gateway_config.proto
    alerting/alerting_statuses.proto

    # Gateway
    frontend/gateway_cloud_config.proto
    frontend/solomon_gateway_config.proto

    # Coremon
    coremon/coremon_cloud_config.proto
    coremon/solomon_coremon_config.proto

    # Dumper
    dumper/solomon_dumper_config.proto

    # DataProxy
    dataproxy/dataproxy_client_config.proto

    # NameResolver
    name_resolver/name_resolver_client_config.proto
    name_resolver/solomon_name_resolver_config.proto

    # ProjectManager
    project_manager/solomon_project_manager_config.proto
)

PEERDIR(
    solomon/protos/configs
)

EXCLUDE_TAGS(GO_PROTO PY_PROTO PY3_PROTO)

END()
