package ru.yandex.solomon.expression.expr;

import javax.annotation.ParametersAreNonnullByDefault;

/**
 * @author Stepan Koltsov
 */
@ParametersAreNonnullByDefault
public interface SelExprVisitor {
    SelExpr visitValue(SelExprValue value);

    SelExpr visitParam(SelExprParam param);

    SelExpr visitOp(SelExprOpCall fnCall);

    SelExpr visitFn(SelExprFuncCall fnCall);

    SelExpr visitCondition(SelExprTern expr);

    SelExpr visitInterpolatedString(SelExprInterpolatedString interpolatedString);

    SelExprSelector visitSelector(SelExprSelector selector);

    SelExpr visitSelectors(SelExprSelectors selectors);

    SelExpr visitObject(SelExprObject object);
}
