package ru.yandex.solomon.name.resolver.client;

import java.util.concurrent.CompletableFuture;

/**
 * @author Vladimir Gordiychuk
 */
public interface NameResolverClient extends AutoCloseable {
    CompletableFuture<FindResponse> find(FindRequest request);
    CompletableFuture<ResolveResponse> resolve(ResolveRequest request);
    CompletableFuture<Void> update(UpdateRequest request);
    CompletableFuture<ShardsResponse> getShardIds();

    @Override
    void close();
}
