package ru.yandex.solomon.search.result;

import java.util.function.IntFunction;
import java.util.stream.Stream;


/**
 * @author Sergey Polovko
 */
public class EmptyResult implements SearchResult {

    private static final int[] EMPTY_ARRAY = {};

    public static final EmptyResult SELF = new EmptyResult();

    private EmptyResult() {
    }

    @Override
    public <T> Stream<T> mapToObj(IntFunction<? extends T> mapper) {
        return Stream.empty();
    }

    @Override
    public int size() {
        return 0;
    }

    @Override
    public int[] toArray() {
        return EMPTY_ARRAY;
    }
}
