package ru.yandex.solomon.codec.compress;

import java.util.NoSuchElementException;

import ru.yandex.solomon.model.point.AggrPoint;

/**
 * @author Vladimir Gordiychuk
 */
public final class EmptyTimeSeriesInputStream implements TimeSeriesInputStream {
    public static EmptyTimeSeriesInputStream INSTANCE = new EmptyTimeSeriesInputStream();

    private EmptyTimeSeriesInputStream() {
    }

    @Override
    public void readPoint(int columnSet, AggrPoint aggrPoint) {
        throw new NoSuchElementException();
    }

    @Override
    public boolean hasNext() {
        return false;
    }

    @Override
    public void close() {
    }
}
