package ru.yandex.solomon.util.io;

/**
 * @author Stepan Koltsov
 *
 * @see java.util.function.Function
 */
public interface IoFunction<A, R> {
    R apply(A a) throws Exception;

    default R applyUnchecked(A a) {
        try {
            return apply(a);
        } catch (Exception ex) {
            throw new RuntimeException(ex);
        }
    }
}
