#!/bin/bash

#### Check ydb cli is working ####

## TESTING
# gateway on laptop
ya ydb -e ydb-ru-prestable.yandex.net:2135 \
    -d /ru-prestable/solomon/development/solomon \
    scheme ls

# coremon on solomon-test-sas-00.search.yandex.net
ydb -e localhost \
    -d /Solomon \
    scheme ls


## PRESTABLE
# gateway on laptop
ya ydb -e ydb-ru-prestable.yandex.net:2135 \
    -d /ru-prestable/solomon/prestable/solomon \
    scheme ls

# coremon on solomon-pre-storage-man-000.search.yandex.net
ydb -e localhost \
    -d /Solomon \
    scheme ls


## CLOUD-PREPROD
# gateway on solomon-gateway-00.svc.cloud-preprod.yandex.net
sudo ydb -e grpcs://solomon-dn.ydb.cloud-preprod.yandex.net:2136 \
    -d /pre-prod_global/solomon \
    --sa-key-file /Berkanavt/keys/solomon/ydb_global_iam.json \
    --iam-endpoint iam.api.cloud-preprod.yandex.net \
    scheme ls

# coremon on solomon-stockpile-00.svc.cloud-preprod.yandex.net
sudo ydb -e localhost \
    -d /pre-prod_sas/solomon \
    scheme ls


## CLOUD-PROD
# gateway on solomon-gateway-00.svc.cloud.yandex.net
sudo ydb -e grpcs://solomon-dn.ydb.cloud.yandex.net:2136 \
    -d /global/solomon \
    --sa-key-file /Berkanavt/keys/solomon/ydb_global_iam.json \
    --iam-endpoint iam.api.cloud.yandex.net \
    scheme ls

# coremon.sas on solomon-stockpile-sas-00.svc.cloud.yandex.net
sudo ydb -e localhost \
    -d /sas/solomon \
    scheme ls

# coremon.vla on solomon-stockpile-vla-00.svc.cloud.yandex.net
sudo ydb -e localhost \
    -d /vla/solomon \
    scheme ls


## PROD
# gateway on solomon-gateway-sas-00.search.yandex.net
sudo ydb -e localhost \
    -d /Kfront \
    scheme ls

# coremon.sas on solomon-storage-sas-000.search.yandex.net
sudo ydb -e localhost \
    -d /Solomon \
    scheme ls

# coremon.vla on solomon-storage-vla-000.search.yandex.net
sudo ydb -e localhost \
    -d /Solomon \
    scheme ls


#### Add column ####

## TESTING
# gateway on laptop
ya ydb -e ydb-ru-prestable.yandex.net:2135 \
    -d /ru-prestable/solomon/development/solomon \
    scripting yql -s 'alter table [Gateway/V1/TaskScheduler/Tasks] ADD COLUMN version Uint32;'

# coremon on solomon-test-sas-00.search.yandex.net
ydb -e localhost \
    -d /Solomon \
    scripting yql -s 'alter table [Solomon/Coremon/V1/TaskScheduler/Tasks] add column version Uint32;'


## PRESTABLE
# gateway on laptop
ya ydb -e ydb-ru-prestable.yandex.net:2135 \
    -d /ru-prestable/solomon/prestable/solomon \
    scripting yql -s 'alter table [Gateway/V1/TaskScheduler/Tasks] ADD COLUMN version Uint32;'

# coremon on solomon-pre-storage-man-000.search.yandex.net
ydb -e localhost \
    -d /Solomon \
    scripting yql -s 'alter table [Solomon/Coremon/V1/TaskScheduler/Tasks] add column version Uint32;'


## CLOUD-PREPROD
# gateway on solomon-gateway-00.svc.cloud-preprod.yandex.net
sudo ydb -e grpcs://solomon-dn.ydb.cloud-preprod.yandex.net:2136 \
    -d /pre-prod_global/solomon \
    --sa-key-file /Berkanavt/keys/solomon/ydb_global_iam.json \
    --iam-endpoint iam.api.cloud-preprod.yandex.net \
    scripting yql -s 'alter table [Gateway/V1/TaskScheduler/Tasks] ADD COLUMN version Uint32;'

# coremon on solomon-stockpile-00.svc.cloud-preprod.yandex.net
sudo ydb -e localhost \
    -d /pre-prod_sas/solomon \
    scripting yql -s 'alter table [meta/Solomon/Coremon/V1/TaskScheduler/Tasks] add column version Uint32;'


## CLOUD-PROD
# gateway on solomon-gateway-00.svc.cloud.yandex.net
sudo ydb -e grpcs://solomon-dn.ydb.cloud.yandex.net:2136 \
    -d /global/solomon \
    --sa-key-file /Berkanavt/keys/solomon/ydb_global_iam.json \
    --iam-endpoint iam.api.cloud.yandex.net \
    scripting yql -s 'alter table [Gateway/V1/TaskScheduler/Tasks] ADD COLUMN version Uint32;'

# coremon.sas on solomon-stockpile-sas-00.svc.cloud.yandex.net
sudo ydb -e localhost \
    -d /sas/solomon \
    scripting yql -s 'alter table [meta/Solomon/Coremon/V1/TaskScheduler/Tasks] add column version Uint32;'

# coremon.vla on solomon-stockpile-vla-00.svc.cloud.yandex.net
sudo ydb -e localhost \
    -d /vla/solomon \
    scripting yql -s 'alter table [meta/Solomon/Coremon/V1/TaskScheduler/Tasks] add column version Uint32;'


## PROD
# gateway on solomon-gateway-sas-00.search.yandex.net
sudo ydb -e localhost \
    -d /Kfront \
    scripting yql -s 'alter table [Solomon/Gateway/V1/TaskScheduler/Tasks] ADD COLUMN version Uint32;'

# coremon.sas on solomon-storage-sas-000.search.yandex.net
sudo ydb -e localhost \
    -d /Solomon \
    scripting yql -s 'alter table [Solomon/Coremon/V1/TaskScheduler/Tasks] add column version Uint32;'

# coremon.vla on solomon-storage-vla-000.search.yandex.net
sudo ydb -e localhost \
    -d /Solomon \
    scripting yql -s 'alter table [Solomon/Coremon/V1/TaskScheduler/Tasks] add column version Uint32;'

## ISRAEL / CLOUDIL
# gateway on gateway-1.mon.yandexcloud.co.il
sudo ydb -e  grpcs://u-lb.solomon.ydb.yandexcloud.co.il:2135 \
    -d /israel_global/solomon \
    --sa-key-file /Berkanavt/keys/solomon/ydb_global_iam.json \
    --iam-endpoint iam.api.cloudil.com \
    scripting yql -s 'ALTER TABLE [Config/V2/Shard] ADD COLUMN numPartitions Int32;'
