package ru.yandex.solomon.alert.cluster.server.grpc.evaluation;

import java.util.concurrent.Flow.Subscriber;

import javax.annotation.Nullable;

import ru.yandex.solomon.alert.domain.Alert;
import ru.yandex.solomon.alert.protobuf.EvaluationStreamServerMessage.Evaluation;
import ru.yandex.solomon.alert.protobuf.TAssignmentSeqNo;
import ru.yandex.solomon.alert.rule.EvaluationState;

/**
 * @author Vladimir Gordiychuk
 */
public record ClientAssignReq(
        TAssignmentSeqNo seqNo,
        Alert alert,
        @Nullable EvaluationState state,
        Subscriber<Evaluation> subscriber)
{
    public static ClientAssignReq of(TAssignmentSeqNo seqNo, Alert alert, @Nullable EvaluationState state, Subscriber<Evaluation> subscriber) {
        return new ClientAssignReq(seqNo, alert, state, subscriber);
    }
}
