package ru.yandex.solomon.alert.inject.spring.notification;

import org.springframework.context.annotation.Condition;
import org.springframework.context.annotation.ConditionContext;
import org.springframework.core.type.AnnotatedTypeMetadata;

import ru.yandex.solomon.config.protobuf.alert.BrokerConfig;

/**
 * @author Vladimir Gordiychuk
 */
public class TelegramCondition implements Condition {
    @Override
    public boolean matches(ConditionContext context, AnnotatedTypeMetadata metadata) {
        var config = context.getBeanFactory().getBean(BrokerConfig.class).getNotificationConfig().getTelegramConfig();
        return !config.getToken().isEmpty() && !config.getBotName().isEmpty();
    }
}
