package ru.yandex.solomon.alert.notification.state;

import java.util.concurrent.CompletableFuture;

import javax.annotation.ParametersAreNonnullByDefault;

import ru.yandex.solomon.alert.notification.NotificationState;
import ru.yandex.solomon.alert.notification.channel.Event;
import ru.yandex.solomon.alert.notification.channel.NotificationStatus;

/**
 * @author Vladimir Gordiychuk
 */
@ParametersAreNonnullByDefault
public interface NotificationChannelState {
    CompletableFuture<NotificationStatus> process(Event event);

    /**
     * Cancel active tasks and move to terminate state
     */
    void cancel();

    NotificationState getNotificationState();
}
