#pragma once

#include <solomon/services/dataproxy/config/cache_config.pb.h>

#include <solomon/libs/cpp/actors/fwd.h>

#include <library/cpp/monlib/metrics/fwd.h>

#include <util/generic/ptr.h>
#include <util/generic/string.h>

namespace NSolomon {
class TActorRuntime;
} // namespace NSolomon

namespace NSolomon::NDataProxy {

class IDataSource;
class TLongTermSourceConfig;
class TClusterMap;

TIntrusivePtr<IDataSource> LongTermSource(
        TActorRuntime& runtime,
        const TLongTermSourceConfig& config,
        const TClusterMap& clusterMap,
        const std::shared_ptr<NMonitoring::TMetricRegistry>& metrics,
        TString clientId = {});

} // namespace NSolomon::NDataProxy
