#pragma once

#include <solomon/services/dataproxy/lib/cluster_id/cluster_id.h>
#include <solomon/services/dataproxy/lib/cluster_id/replica_map.h>
#include <solomon/services/dataproxy/lib/datasource/query.h>
#include <solomon/services/dataproxy/lib/shard/shard_id.h>
#include <solomon/services/dataproxy/lib/shard/shard_key.h>

#include <library/cpp/containers/absl_flat_hash/flat_hash_set.h>

#include <grpc++/support/status_code_enum.h>

namespace yandex::monitoring::memstore {
class UniqueLabelsResponse;
} // namespace yandex::monitoring::memstore

namespace NSolomon::NDataProxy {

class TUniqueLabelsMerger {
public:
    void AddResponse(const yandex::monitoring::memstore::UniqueLabelsResponse& resp);

    void AddError(TClusterId clusterId, TShardId shardId, grpc::StatusCode statusCode, TString message);

    std::unique_ptr<TUniqueLabelsResult> Finish();

private:
    NStringPool::TStringPoolBuilder Strings_;
    absl::flat_hash_set<TLabels<ui32>> Labels_;
    TDataSourceErrors Errors_;
};

} // namespace NSolomon::NDataProxy
