package ru.yandex.solomon.dumper;

import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Import;

import ru.yandex.solomon.config.thread.LazyThreadPoolProvider;
import ru.yandex.solomon.ctx.ServiceAuthContext;
import ru.yandex.solomon.dumper.spring.DumperContext;
import ru.yandex.solomon.http.filters.RequestLoggingFilter;
import ru.yandex.solomon.selfmon.GeneralMonitoringContext;
import ru.yandex.solomon.selfmon.mon.SelfMetricsController;
import ru.yandex.solomon.staffOnly.StaffOnlyController;
import ru.yandex.solomon.staffOnly.StaffOnlyRedirectController;
import ru.yandex.solomon.tracing.TracingContext;

/**
 * @author Sergey Polovko
 */
@Import({
        RequestLoggingFilter.class,
        SelfMetricsController.class,
        StaffOnlyController.class,
        StaffOnlyRedirectController.class,
        LazyThreadPoolProvider.class,
        GeneralMonitoringContext.class,
        ServiceAuthContext.class,
        DumperContext.class,
        TracingContext.class,
})
@Configuration
public class DumperMainContext {
}
