package ru.yandex.solomon.gateway.api.v3alpha.cloud.priv;

import java.util.concurrent.CompletableFuture;

import javax.annotation.ParametersAreNonnullByDefault;

import com.google.protobuf.Empty;

import ru.yandex.monitoring.v3.cloud.ServiceDashboard;
import ru.yandex.monitoring.v3.cloud.priv.CreateServiceDashboardRequest;
import ru.yandex.monitoring.v3.cloud.priv.DeleteServiceDashboardRequest;
import ru.yandex.monitoring.v3.cloud.priv.GetServiceDashboardRequest;
import ru.yandex.monitoring.v3.cloud.priv.ListServiceDashboardRequest;
import ru.yandex.monitoring.v3.cloud.priv.ListServiceDashboardResponse;
import ru.yandex.monitoring.v3.cloud.priv.SyncServiceDashboardRequest;
import ru.yandex.monitoring.v3.cloud.priv.UpdateServiceDashboardRequest;
import ru.yandex.monitoring.v3.cloud.priv.ValidateServiceDashboardRequest;
import ru.yandex.monitoring.v3.cloud.priv.ValidationServiceDashboardResponse;
import ru.yandex.solomon.auth.AuthSubject;

/**
 * @author Oleg Baryshnikov
 */
@ParametersAreNonnullByDefault
public interface PrivServiceDashboardService {
    CompletableFuture<ServiceDashboard> get(GetServiceDashboardRequest request, AuthSubject authSubject);

    CompletableFuture<ListServiceDashboardResponse> list(ListServiceDashboardRequest request, AuthSubject authSubject);

    CompletableFuture<ServiceDashboard> create(CreateServiceDashboardRequest request, AuthSubject authSubject);

    CompletableFuture<ServiceDashboard> update(UpdateServiceDashboardRequest request, AuthSubject authSubject);

    CompletableFuture<ValidationServiceDashboardResponse> validate(ValidateServiceDashboardRequest request, AuthSubject authSubject);

    CompletableFuture<ServiceDashboard> sync(SyncServiceDashboardRequest request, AuthSubject authSubject);

    CompletableFuture<ValidationServiceDashboardResponse> validateSync(SyncServiceDashboardRequest request, AuthSubject authSubject);

    CompletableFuture<Empty> delete(DeleteServiceDashboardRequest request, AuthSubject authSubject);
}
