package ru.yandex.solomon.gateway.utils;

import javax.annotation.ParametersAreNonnullByDefault;


/**
 * @author Stepan Koltsov
 */
@ParametersAreNonnullByDefault
public class UserLinksBasic {

    public static final String GRAPH_ONLY_QA = "graphOnly";
    public static final String LABEL_NAME_QA_PREFIX = "l.";
    public static final String NEED_POINTS_PARAM = "points";
    public static final String DROP_NANS_PARAM = "dropNaN";
    public static final String FORCE_HOST_PARAM = "forceHost";
    public static final String FORCE_CLUSTER_PARAM = "forceCluster";
    public static final String FORCE_HOST_LOCAL_VALUE = "local";
    public static final String REVIVER_CLIENT_ID = "reviverClientId";

    public static final String PROJECT = "project";
    public static final String CLUSTER = "cluster";
    public static final String SERVICE = "service";

    public static final String GRAPH_PARAM = "graph";
    public static final String DASHBOARD_PARAM = "dashboard";

    public static final String GRAPH_VALUE_AUTO = "auto";

    public static final String GRAPH_DESCRIPTION = "description";

    public static final String SCALE_PARAM = "scale";
    public static final String SCALE_NATURAL = "natural";
    public static final String SCALE_LOG = "log";

    public static final String STACK_PARAM = "stack";

    public static final String NORM_PARAM = "norm";
    public static final String LEGEND_QUERY_ARG = "legend";
    public static final String HIDE_NO_DATA_QUERY_ARG = "hideNoData";

    public static final String INTERPOLATE_PARAM = "interpolate";

    public static final String GRAPH_MODE = "graphMode";
    public static final String SECONDARY_GRAPH_MODE = "secondaryGraphMode";

    public static final String COLOR_SCHEME_QUERY_ARG = "cs";
    public static final String COLOR_SCHEME_GRADIENT = "gradient";

    public static final String GRAPH_MODE_GRAPH = "graph";
    public static final String GRAPH_MODE_PIE_CHART = "pieChart";
    public static final String GRAPH_MODE_BARS = "bars";
    public static final String GRAPH_MODE_DISTRIBUTION = "distribution";
    public static final String GRAPH_MODE_HEATMAP = "heatmap";
    public static final String GRAPH_MODE_NONE = "none";

    public static final String HEATMAP_GREEN_VALUE_QUERY_ARG = "greenValue";
    public static final String HEATMAP_YELLOW_VALUE_QUERY_ARG = "yellowValue";
    public static final String HEATMAP_RED_VALUE_QUERY_ARG = "redValue";
    public static final String HEATMAP_VIOLET_VALUE_QUERY_ARG = "violetValue";

    public static final String GRAPH_NUMBER_FORMAT = "numberFormat";

    public static final String GREEN_QUERY_ARG = "green";
    public static final String YELLOW_QUERY_ARG = "yellow";
    public static final String RED_QUERY_ARG = "red";
    public static final String VIOLET_QUERY_ARG = "violet";

    public static final String AGGR_PARAM = "aggr";

    public static final String MIN_PARAM = "min";
    public static final String MAX_PARAM = "max";

    public static final String AUTOREFRESH_QA = "autorefresh";
    public static final String B_QA = "b";
    public static final String E_QA = "e";
    public static final String CHECKS_QA = "checks";
    public static final String IS_BACKGROUND_QUERY_PARAM = "backgroudQuery";

    public static final String LIMIT_PARAM = "limit";

    public static final String PERCENTILE_PARAM = "percentiles";

    public static final String IGNORE_INF_PARAM = "ignoreInf";
    public static final String BUCKET_LABEL_PARAM = "bucketLabel";

    public static final String METADATA_VERSION_HASH_PARAM = "clientMetaDataVersionHash";

    public static final String SOLOMON_CLIENT_VERSION = "solomonClientVersion";

    public static final String WHO = "who";

    public static final String SHOW_CENSORED_INTERVALS = "showCensoredIntervals";
    public static final String DATA_DELAY = "dataDelay";
    public static final String SENSORS = "sensors";
    public static final String SENSORS_DATA = "sensorsData";

    // param to distinct user action from autorefresh (https://st.yandex-team.ru/SOLOMON-1466)
    public static final String COUNT_USAGE = "countUsage";

    public static final String CHART_BORDER_WIDTH = "chartBorderWidth";
    public static final String DISTRIBUTION_MODE = "distributionMode";

    public static final String TRANSFORM = "transform";
    public static final String OVER_LINES_TRANSFORM = "overLinesTransform";

    public static final String SP_CLUSTER = "spCluster";
    public static final String SP_BACKUP = "spBackup";
    public static final String SP_ETERNITY_ONLY = "spEternityOnly";
    public static final String SP_SHARD = "spShard";

    public static final String MIN_DATAMIN = "datamin";

    public static final String FILTER = "filter";
    public static final String FILTER_BY = "filterBy";
    public static final String FILTER_LIMIT = "filterLimit";

    // Downsampling params
    public static final String DOWNSAMPLING = "downsampling";
    public static final String DOWNSAMPLING_AGGR = "downsamplingAggr";
    public static final String GRID = "grid";
    public static final String MAX_POINTS = "maxPoints";
    public static final String DOWNSAMPLING_FILL = "downsamplingFill";
    public static final String IGNORE_MIN_STEP_MILLIS = "ignoreMinStepMillis";

    // Downsampling aggr values
    public static final String DOWNSAMPLING_PARAM_AUTO = "auto";
    public static final String DOWNSAMPLING_PARAM_WITHOUT_GRID = "withoutGrid";
    public static final String DOWNSAMPLING_PARAM_BY_INTERVAL = "byInterval";
    public static final String DOWNSAMPLING_PARAM_BY_POINTS = "byPoints";
    public static final String DOWNSAMPLING_PARAM_OFF = "off";

    // For Data API
    public static final String DOWNSAMPLING_PARAM_RAW = "raw";

    public static final String MOVING_WINDOW = "movingWindow";
    public static final String MOVING_PERCENTILE = "movingPercentile";

    public static final String ORDER_BY_PARAM_DEPRECATED = "orderBy";
    public static final String ASC_PARAM_DEPRECATED = "asc";
}
