package ru.yandex.solomon.name.resolver.logbroker;

import ru.yandex.persqueue.PersqueueClient;

/**
 * @author Vladimir Gordiychuk
 */
public class PersqueueInstance implements AutoCloseable {

    private final PersqueueClient client;
    private final PersqueueReader reader;

    public PersqueueInstance(PersqueueClient client, PersqueueReader reader) {
        this.client = client;
        this.reader = reader;
    }

    public void start() {
        reader.start();
    }

    @Override
    public void close() {
        reader.close();
        client.close();
    }
}
