JAVA_PROGRAM(stockpile)

OWNER(g:solomon)

INCLUDE(${ARCADIA_ROOT}/solomon/libs/java/jdk.inc)

JAVA_SRCS(
    PACKAGE_PREFIX ru.yandex.stockpile
    SRCDIR src
    **/*.java
    **/*.json
    **/*.pbtext
)

INCLUDE(${ARCADIA_ROOT}/solomon/libs/java/contribs.inc)

PEERDIR(
    library/cpp/monlib/encode/legacy_protobuf/protos

    # spring
    contrib/java/org/springframework/spring-aop
    contrib/java/org/springframework/spring-beans
    contrib/java/org/springframework/spring-context
    contrib/java/org/springframework/spring-core
    contrib/java/org/springframework/spring-expression
    contrib/java/org/springframework/spring-test
    contrib/java/org/springframework/spring-web
    contrib/java/javax/annotation/javax.annotation-api

    # solomon deps
    solomon/libs/java/auth
    solomon/libs/java/balancer
    solomon/libs/java/cluster-discovery
    solomon/libs/java/conf-db
    solomon/libs/java/distributed-lock
    solomon/libs/java/http-filters
    solomon/libs/java/main
    solomon/libs/java/service-ctx
    solomon/libs/java/stockpile-client
    solomon/libs/java/tracing
    solomon/libs/java/concurrency-limits-actors

    iceberg/misc-cmdline
    iceberg/commune-protobuf5
)

EXCLUDE(${service_excludes})

CHECK_JAVA_DEPS(yes)

LINT(base)
END()

RECURSE_FOR_TESTS(
    conftest
    ut
)
