import { PureComponent } from 'react';
import PropTypes from 'prop-types';

class Measurer extends PureComponent {
  componentDidMount() {
    console.timeEnd(this.props.title);
  }

  render() {
    console.time(this.props.title);
    return this.props.children;
  }
}

Measurer.propTypes = {
  title: PropTypes.string.isRequired,
  children: PropTypes.element.isRequired,
};

export default Measurer;
