import React from 'react';
import { Provider } from 'react-redux';
import { MemoryRouter } from 'react-router-dom';

import store from './store';

const StoryDecorator = (getStory) => (
  <Provider store={store}>
    <div id="root">
      <MemoryRouter>
        <div className="container" style={{ marginTop: '10px' }}>
          {getStory()}
        </div>
      </MemoryRouter>
    </div>
  </Provider>
);

export default StoryDecorator;
